#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Fri Dec  8 12:35:26 2017

@author: dav
"""

import numpy as np

from sklearn.cluster import DBSCAN

import os


def clustering(inarray,
               outfile,
               eps=2.51,
               min_samples=40,
               n_jobs=3):
    
    # Run the dbscan clustering algorithim
    c = DBSCAN(eps=eps, min_samples=min_samples, n_jobs=n_jobs).fit(inarray[:,0:2])
    
    # boolean mask for inputs, clusters, labels
    odata = np.column_stack((inarray,c.labels_))[c.core_sample_indices_,:]
    
    np.savetxt(outfile, odata)
    
    return odata

def refinery(data,output):
    labels = np.unique(data[:,4])
    
    odata = None
    
    for l in labels:
        if not l == -1:
            c = data[:,4]==l
            
            cpts = data[c,:]
            
            centerx, centery = np.mean(cpts[:,0]),np.mean(cpts[:,1])
            
            n_pts = cpts.shape[0]
            
            xstd, ystd = np.std(cpts[:,0]),np.std(cpts[:,1])
            
            radmin,radmax = np.min(cpts[:,3]),np.max(cpts[:,3])
            
            radmean,radstd = np.mean(cpts[:,3]),np.std(cpts[:,3])
            
            smin,smax= np.min(cpts[:,2]),np.max(cpts[:,2])
            
            smean,sstd=np.mean(cpts[:,2]),np.std(cpts[:,2])
            
            ssum = np.sum(cpts[:,2])
            
            a = np.array([centerx,
                          centery,
                          n_pts,
                          xstd,
                          ystd,
                          radmin,
                          radmax,
                          radmean,
                          radstd,
                          smin,
                          smax,
                          smean,
                          sstd,
                          ssum])
            
            if odata is None:
                odata = a
                
            else:
                odata = np.vstack((odata,a))
                
    np.savetxt(output,odata)
                
    return odata
    
if __name__ == '__main__':
    infile = r'C:\Users\au526889\Dropbox\borgring python\template_matching\collated_20171212.txt'
    
    #ind = np.loadtxt(infile, delimiter=';')
    
    outfile = r'C:\Users\au526889\Dropbox\borgring python\template_matching\collated_20171212_dbscan.txt'
    
    #odata = clustering(ind, outfile)
    
    
    
    
    
    